 
#ifdef LICENSE

/*
 * (c) 2006 AUTHOR_NAME 
 */


#endif
 
#ifdef SHORT_DESCRIPTION

Add short description here. Will appear in HTML documentation.

#endif
 
#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



/*
 *           STATES STRUCTURE 
 */ 
typedef struct {
       float   __lastIn;
       int   __count;
       float   __halfVcc;
       float   __vout;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES 
 */ 
#define  lastIn  (state_P->__lastIn)
#define  count  (state_P->__count)
#define  halfVcc  (state_P->__halfVcc)
#define  vout  (state_P->__vout)

/*         
 *    INPUT BUFFER DEFINES 
 */ 
#define x(DELAY) (*(( float   *)PIN(0,DELAY)))

/*         
 *    OUTPUT BUFFER  DEFINES 
 */ 
#define y(delay) *( float   *)POUT(0,delay)

/*         
 *    PARAMETER DEFINES 
 */ 
#define N (param_P[0]->value.d)
#define vdd (param_P[1]->value.f)
#define vss (param_P[2]->value.f)
/*-------------- BLOCK CODE ---------------*/
 int  
DBN
(int run_state,block_Pt block_P)

{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;

     
	state_Pt state_P = (state_Pt)star_P->state_P;
     
/*
 *              Declarations 
 */
 

   	int i;
   	float sample;
   	float inState;


switch (run_state) {

 
 


 
case PARAM_INIT: 
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = " N  ( Divide by N ) ";
     char   *ptype0 = "int";
     char   *pval0 = "1";
     char   *pname0 = "N";
     char   *pdef1 = " VDD ";
     char   *ptype1 = "float";
     char   *pval1 = "1.0";
     char   *pname1 = "vdd";
     char   *pdef2 = " VSS ";
     char   *ptype2 = "float";
     char   *pval2 = "0.0";
     char   *pname2 = "vss";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);
KrnModelParam(indexModel88,1 ,pdef1,ptype1,pval1,pname1);
KrnModelParam(indexModel88,2 ,pdef2,ptype2,pval2,pname2);

      }
break;
   


/*         
 *    OUTPUT BUFFER SYSTEM  INITS 
 */ 
 case OUTPUT_BUFFER_INIT: 
 {
 int indexOC = block_P->model_index;
     char   *ptypeOut0 = " float ";
     char   *pnameOut0 = " y ";
KrnModelConnectionOutput(indexOC,0 ,pnameOut0,ptypeOut0);
}
 break;

/*         
 *    INPUT BUFFER SYSTEM  INITS 
 */ 
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = " float ";
     char   *pnameIn0 = " x ";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE 
 */
case SYSTEM_INIT:
     
	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
             lastIn = 0 ;
        count = 0 ;
        halfVcc = 0 ;
        vout = 0 ;



         
   if(NO_OUTPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 outputs expected; %d connected\n",
              STAR_NAME,NO_OUTPUT_BUFFERS());
	      return(201);
   }

   SET_CELL_SIZE_OUT(0,sizeof( float ));

         
   if(NO_INPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof( float ));

break;

/*
 *               USER INITIALIZATION CODE 
 */
case USER_INIT: 

 
     halfVcc = (vdd - vss) / 2.0;


break;

/* 
 *             MAIN CODE 
 */
case MAIN_CODE: 

 




while(IT_IN(0)) {
       sample=x(0);
       inState = sample > halfVcc;
 
	    if (inState && !lastIn || !inState && lastIn) {
		     ++count;
		    if (count >= N) {
			     if (vout > halfVcc) {
			     
			              vout=vss;
				         
				              //vdiv=_vss->v();
			     } else {
				         vout=vdd;
				         //vdiv=_vcc->v();
			     }
			     count = 0;
		    }
	    } 
	    lastIn = inState;
  
   
   	   /*
	    * ready output buffer for sample
	    * check for overflow
	    */
	   if(IT_OUT(0)) {
				KrnOverflow("DBN",0);
				return(99);
	   }
	   /*
	    * output the sample
	    */
	   y(0)=vout;


}
    


break;

/*             
 *            WRAPUP CODE 
 */
case WRAPUP: 

 



break;
}
return(0);
}
