
#ifdef LICENSE

/*
    Capsim (r) Text Mode Kernel (TMK)
    Copyright (C) 1989-2017  Silicon DSP  Corporation

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    http://www.silicondsp.com
    Silicon DSP  Corporation
    Las Vegas, Nevada
*/

#endif

#ifdef SHORT_DESCRIPTION

Add short description here. Will appear in HTML documentation.

#endif

#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



/*
 *           STATES STRUCTURE
 */
typedef struct {
       int   __stateVariable;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES
 */
#define  stateVariable  (state_P->__stateVariable)

/*
 *    INPUT BUFFER DEFINES
 */
#define x(DELAY) (*(( float   *)PIN(0,DELAY)))
#define y(DELAY) (*(( float   *)PIN(1,DELAY)))

/*
 *    OUTPUT BUFFER  DEFINES
 */
#define z(delay) *( float   *)POUT(0,delay)

/*
 *    PARAMETER DEFINES
 */
#define thisSampleParameter (param_P[0]->value.f)
/*-------------- BLOCK CODE ---------------*/

add2
(run_state,block_P)

	int run_state;
	block_Pt block_P;
{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;


	state_Pt state_P = (state_Pt)star_P->state_P;

/*
 *              Declarations
 */


   	int j;
   	float sample0;
   	float sample1;


switch (run_state) {






case PARAM_INIT:
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = " Sample Parameter Definition ";
     char   *ptype0 = "float";
     char   *pval0 = "1999.99";
     char   *pname0 = "thisSampleParameter";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);

      }
break;



/*
 *    OUTPUT BUFFER SYSTEM  INITS
 */
 case OUTPUT_BUFFER_INIT:
 {
 int indexOC = block_P->model_index;
     char   *ptypeOut0 = " float ";
     char   *pnameOut0 = " z ";
KrnModelConnectionOutput(indexOC,0 ,pnameOut0,ptypeOut0);
}
 break;

/*
 *    INPUT BUFFER SYSTEM  INITS
 */
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = " float ";
     char   *pnameIn0 = " x ";
     char   *ptypeIn1 = " float ";
     char   *pnameIn1 = " y ";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
KrnModelConnectionInput(indexIC,1 ,pnameIn1,ptypeIn1);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE
 */
case SYSTEM_INIT:

	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
             stateVariable = 0 ;




   if(NO_OUTPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 outputs expected; %d connected\n",
              STAR_NAME,NO_OUTPUT_BUFFERS());
	      return(201);
   }

   SET_CELL_SIZE_OUT(0,sizeof( float ));


   if(NO_INPUT_BUFFERS() != 2 ){
       fprintf(stdout,"%s:2 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof( float ));

   SET_CELL_SIZE_IN(1,sizeof( float ));

break;

/*
 *               USER INITIALIZATION CODE
 */
case USER_INIT:





break;

/*
 *             MAIN CODE
 */
case MAIN_CODE:






for(j= MIN_AVAIL(); j >0; --j)  {
       IT_IN(0);
       IT_IN(1);
       sample0=x(0);
       sample1=y(0);

   	   /*
	    * ready output buffer for sample
	    * check for overflow
	    */
	   if(IT_OUT(0)) {
				KrnOverflow("add2",0);
				return(99);
	   }
	   /*
	    * output the sample
	    */
	   z(0)=sample0+sample1;


}



break;

/*
 *            WRAPUP CODE
 */
case WRAPUP:





break;
}
return(0);
}
