<BLOCK>
<LICENSE>
/*  
    Capsim (r) Text Mode Kernel (TMK) 
    Copyright (C) 1989-2017  Silicon DSP  Corporation 

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    http://www.silicondsp.com
    Silicon DSP  Corporation
    Las Vegas, Nevada
*/

</LICENSE>
<BLOCK_NAME>

imp 

</BLOCK_NAME> 

<COMMENTS>
<![CDATA[ 

/* imp.s */
/**********************************************************************
                          imp()
************************************************************************
This star sends out a unit sample, then a number of zero samples. The 
only parameter, which defaults to NUMBER_SAMPLES_PER_VISIT, sets the total samples
to send out.
<NAME>
impulse
</NAME>
<DESCRIPTION>
This star sends out a unit sample, then a number of zero samples. The 
only parameter, which defaults to NUMBER_SAMPLES_PER_VISIT, sets the total samples
to send out.
</DESCRIPTION>
<PROGRAMMERS>
Mod: ljfaber 12/87 add 'auto fanout'
Mod: removed auto fanout to test for systemc May 2007
</PROGRAMMERS>
*/

]]>
</COMMENTS> 

    
<DESC_SHORT>
This star sends out a unit sample, then a number of zero samples.
</DESC_SHORT>

<STATES>
	<STATE>
		<TYPE>int</TYPE>
		<NAME>samples_out</NAME>
		<VALUE>0</VALUE>
	</STATE>
	<STATE>
		<TYPE>int</TYPE>
		<NAME>no_obuf</NAME>
	</STATE>
</STATES>
 
<DECLARATIONS> 

	int i,j;

</DECLARATIONS> 

<OUTPUT_BUFFERS>
        <BUFFER>
                <TYPE> float </TYPE>
                <NAME> y </NAME>
        </BUFFER>
</OUTPUT_BUFFERS>

     

<PARAMETERS>
<PARAM>
	<DEF>Enter number of samples</DEF>
	<TYPE>int</TYPE>
	<NAME>length</NAME>
	<VALUE>128</VALUE>
</PARAM>
</PARAMETERS>

<INIT_CODE>
<![CDATA[ 


]]>
</INIT_CODE> 


<MAIN_CODE>
<![CDATA[ 


	for (i=0; i<NUMBER_SAMPLES_PER_VISIT; i++) {
     
		if (samples_out++ >= length) return(0);

			if(IT_OUT(0)) {
				KrnOverflow("imp",0);
				return(99);
			}

			if(samples_out > 1) y(0) = 0.;
			else 	y(0) = 1.;
	}
	return(0);


]]>
</MAIN_CODE> 

<WRAPUP_CODE>
<![CDATA[ 


]]>
</WRAPUP_CODE> 



</BLOCK> 

