
#ifdef LICENSE

/*
    Capsim (r) Text Mode Kernel (TMK)
    Copyright (C) 1989-2017  Silicon DSP  Corporation

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    http://www.silicondsp.com
    Silicon DSP  Corporation
    Las Vegas, Nevada
*/


#endif

#ifdef SHORT_DESCRIPTION

Add short description here. Will appear in HTML documentation.

#endif

#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



/*
 *           STATES STRUCTURE
 */
typedef struct {
       float   __xd;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES
 */
#define  xd  (state_P->__xd)

/*
 *    INPUT BUFFER DEFINES
 */
#define x(DELAY) (*(( float   *)PIN(0,DELAY)))

/*
 *    OUTPUT BUFFER  DEFINES
 */
#define y(delay) *( float   *)POUT(0,delay)

/*
 *    PARAMETER DEFINES
 */
#define samplesDelay (param_P[0]->value.d)
/*-------------- BLOCK CODE ---------------*/

udelay
(run_state,block_P)

	int run_state;
	block_Pt block_P;
{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;


	state_Pt state_P = (state_Pt)star_P->state_P;

/*
 *              Declarations
 */


   	int i;
   	float sample;


switch (run_state) {






case PARAM_INIT:
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = "  Samples to Delay  ";
     char   *ptype0 = "int";
     char   *pval0 = "1";
     char   *pname0 = "samplesDelay";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);

      }
break;



/*
 *    OUTPUT BUFFER SYSTEM  INITS
 */
 case OUTPUT_BUFFER_INIT:
 {
 int indexOC = block_P->model_index;
     char   *ptypeOut0 = " float ";
     char   *pnameOut0 = " y ";
KrnModelConnectionOutput(indexOC,0 ,pnameOut0,ptypeOut0);
}
 break;

/*
 *    INPUT BUFFER SYSTEM  INITS
 */
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = " float ";
     char   *pnameIn0 = " x ";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE
 */
case SYSTEM_INIT:

	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
             xd = 0 ;


  delay_max(star_P->inBuffer_P[0],samplesDelay + 1);
  delay_min(star_P->inBuffer_P[0],samplesDelay);


   if(NO_OUTPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 outputs expected; %d connected\n",
              STAR_NAME,NO_OUTPUT_BUFFERS());
	      return(201);
   }

   SET_CELL_SIZE_OUT(0,sizeof( float ));


   if(NO_INPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof( float ));

break;

/*
 *               USER INITIALIZATION CODE
 */
case USER_INIT:


   xd=0;


break;

/*
 *             MAIN CODE
 */
case MAIN_CODE:






while(IT_IN(0)) {

   	   /*
	    * ready output buffer for sample
	    * check for overflow
	    */
	   if(IT_OUT(0)) {
				KrnOverflow("udelay",0);
				return(99);
	   }
	   /*
	    * output the sample
	    */
	   y(0)=x(samplesDelay);


}



break;

/*
 *            WRAPUP CODE
 */
case WRAPUP:





break;
}
return(0);
}
